
#include "stdafx.h"

#ifndef TEST
#include "RegExp.h"
#endif

#include "Engine.h"

void scan_regexp(char *regexp, char *expr, char cmd, int pos);
void read_string(char *name);
//void mycopy(char **dst, BSTR *src);
//void myfree(char *dst);
void close_files(void);
void init(void);

extern int output_art;
extern char *output_cstr;
extern int output_count;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int globalerror;

/////////////////////////////////////////////////////////////////////////////
// Engine

#ifndef TEST
IMPLEMENT_DYNCREATE(Engine, CCmdTarget)

Engine::Engine()
{
	EnableAutomation();
	
	// To keep the application running as long as an OLE automation 
	//	object is active, the constructor calls AfxOleLockApp.
   Reset();
	AfxOleLockApp();
}

Engine::~Engine()
{
	// To terminate the application when all objects created with
	// 	with OLE automation, the destructor calls AfxOleUnlockApp.
	
	AfxOleUnlockApp();
}

void Engine::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(Engine, CCmdTarget)
	//{{AFX_MSG_MAP(Engine)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(Engine, CCmdTarget)
	//{{AFX_DISPATCH_MAP(Engine)
	DISP_PROPERTY(Engine, "ReplacePosition", m_replacePosition, VT_I2)
	DISP_PROPERTY(Engine, "ReplacePerLine", m_replacePerLine, VT_BOOL)
	DISP_PROPERTY(Engine, "NoMatch", m_noMatch, VT_BOOL)
	DISP_PROPERTY(Engine, "Line", m_line, VT_I4)
	DISP_PROPERTY(Engine, "Position", m_position, VT_I4)
	DISP_PROPERTY(Engine, "GlobalPosition", m_globalPosition, VT_I4)
	DISP_PROPERTY(Engine, "Error", m_error, VT_BOOL)
	DISP_FUNCTION(Engine, "Replace", Replace, VT_BSTR, VTS_BSTR VTS_BSTR VTS_BSTR)
	DISP_FUNCTION(Engine, "Match", Match, VT_I2, VTS_BSTR VTS_BSTR)
	DISP_FUNCTION(Engine, "FindFirst", FindFirst, VT_EMPTY, VTS_BSTR VTS_BSTR)
	DISP_FUNCTION(Engine, "FindNext", FindNext, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(Engine, "InStr", InStr, VT_I4, VTS_I4 VTS_BSTR VTS_BSTR)
	DISP_PROPERTY_PARAM(Engine, "Text", GetText, SetText, VT_BSTR, VTS_I2)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IEngine to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {28CFE804-5D70-11D2-9407-006097A40DDA}
static const IID IID_IEngine =
{ 0x28cfe804, 0x5d70, 0x11d2, { 0x94, 0x7, 0x0, 0x60, 0x97, 0xa4, 0xd, 0xda } };

BEGIN_INTERFACE_MAP(Engine, CCmdTarget)
	INTERFACE_PART(Engine, IID_IEngine, Dispatch)
END_INTERFACE_MAP()

// {28CFE805-5D70-11D2-9407-006097A40DDA}
IMPLEMENT_OLECREATE(Engine, "REGEXP.ENGINE", 0x28cfe805, 0x5d70, 0x11d2, 0x94, 0x7, 0x0, 0x60, 0x97, 0xa4, 0xd, 0xda)

#endif

void Engine::Reset(void)
{
   m_replacePosition=0;
   m_replacePerLine=TRUE;

   findnr=0;
	m_noMatch=TRUE;
	m_line=0;
	m_position=0;
	m_globalPosition=0;
   m_error=FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Engine message handlers

BSTR Engine::Replace(LPCTSTR in, LPCTSTR regexp, LPCTSTR expr) 
{
	CString strResult;
   if (!strlen(regexp)) { m_error=TRUE; return strResult.AllocSysString(); }
   globalerror=FALSE;

   FILE *sout=freopen("NUL", "w", stdout);
 
   init();
   output_art=1;

   scan_regexp((char*)regexp, (char*)expr, 's', m_replacePosition);
   if (!globalerror) read_string((char*)in, 0, m_replacePerLine);

   close_files();

   fclose(sout);

   if (output_cstr && !globalerror) { strResult=output_cstr; free(output_cstr); output_cstr=0; }
   m_error=globalerror;
   return strResult.AllocSysString();
}

short Engine::Match(LPCTSTR in, LPCTSTR regexp) 
{
   if (!strlen(regexp)) { m_error=TRUE; return 0; }
   globalerror=FALSE;
   FILE *sout=freopen("NUL", "w", stdout);
 
   init();
   output_art=0;

   scan_regexp((char*)regexp, 0, 'z', 0);
   if (!globalerror) read_string((char*)in, 0, TRUE);

   close_files ();

   fclose(sout);

	return output_count;
}

void Engine::FindFirst(LPCTSTR in, LPCTSTR regexp) 
{
   globalerror=FALSE;
   findnr=1;
   findstr=in;
   findregexp=regexp;
   find();
   m_error=globalerror;
}

void Engine::FindNext() 
{
   globalerror=FALSE;
   m_error=globalerror;
   if (m_noMatch) return;
   findnr++;
   find();
   m_error=globalerror;
}

void Engine::find(void)
{
   // sucht die Stelle 'findnr'
   // setzt m_noMatch, m_line, m_position, m_globalPosition

   m_noMatch=TRUE;
   if (!strlen(findregexp)) { globalerror=TRUE; return; }

   FILE *sout=freopen("NUL", "w", stdout);
 
   init();
   output_art=0;
   findnr_tmp=findnr;

   scan_regexp((char*)(LPCTSTR)findregexp, 0, 'f', 0);
   if (!globalerror) read_string((char*)(LPCTSTR)findstr, 1, TRUE);

   close_files ();

   fclose(sout);

   if (m_noMatch) 
   {
      findnr=0; 
      findstr=""; findregexp=""; 
      m_line=0; m_position=0; m_globalPosition=0;
   }
   else
   {
      for (int index=0; index<=9; index++)
         if (regs.end[index]>regs.start[index])
         {
            char *n=new char[regs.end[index]-regs.start[index]+1];
            strncpy(n, line.text+regs.start[index], regs.end[index]-regs.start[index]);
            n[regs.end[index]-regs.start[index]]=0;
            txt[index]=n;
            delete [] n;
         }
         else
            txt[index]="";
   }
}

long Engine::InStr(long position, LPCTSTR in, LPCTSTR regexp) 
{
   if (!strlen(regexp)) { m_error=TRUE; return 0; }
   long ret=0;
   globalerror=FALSE;
   char *instr=(char*)(LPCTSTR)in;
   if (position<1) position=1;
   if (position<=(long)strlen(instr)) 
   {   
      BOOL tmp1=m_noMatch;
      long tmp2=m_line, tmp3=m_position, tmp4=m_globalPosition;

      FILE *sout=freopen("NUL", "w", stdout);
 
      init();
      output_art=0;
      m_noMatch=TRUE;
      findnr_tmp=1;

      scan_regexp((char*)(LPCTSTR)regexp, 0, 'f', 0);
      if (!globalerror) read_string(&instr[position-1], 1, TRUE);

      close_files ();

      fclose(sout);

      ret=m_noMatch?0:(m_globalPosition+position-1);
      m_noMatch=tmp1;
      m_line=tmp2; m_position=tmp3; m_globalPosition=tmp4;
   }
   m_error=globalerror;
   return ret;
}

BSTR Engine::GetText(short index) 
{
	CString strResult;
   if (index>=0 && index<=9 && !m_noMatch) strResult=txt[index];
	return strResult.AllocSysString();
}

void Engine::SetText(short index, LPCTSTR lpszNewValue) 
{
	// readonly
}
